#include "math.h"
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,16,2);

const int signalPin = A0;             // Analog input pin for signal
int signalThreshold = 10;            // Signal threshold for peak detection
unsigned long firstPeakTime = 0;      // Time of the first peak
unsigned long timeBetweenPeaks = 0;   // Time between two peaks
unsigned int measurementCount = 0;    // Counter for peak measurements
unsigned long totalPeakTime = 0;      // Total time between peaks
bool secondPeakDetect = false;

void setup() {
  pinMode(signalPin, INPUT);
  Serial.begin(9600);
  lcd.init();

}

void loop() {
  int sensorValue = analogRead(signalPin);
  lcd.backlight();
  lcd.setCursor(0,0);
  lcd.print("Current rpm: ");
  
  // Detect first peak
  if (sensorValue > signalThreshold && firstPeakTime == 0) {
    firstPeakTime = millis();
  }

  if (sensorValue < signalThreshold && firstPeakTime != 0){
    secondPeakDetect = true;
  }

  // Detect second peak
  if (sensorValue > signalThreshold && secondPeakDetect) {
    timeBetweenPeaks = millis() - firstPeakTime;
    totalPeakTime += timeBetweenPeaks;
    measurementCount++;

    // Reset variables for next measurement
    firstPeakTime = 0;
    secondPeakDetect = false;

    // Calculate average after 4 measurements
    if (measurementCount == 2) {
      float averagePeakTime = (totalPeakTime / 2);
      float rpm = 30000 / (averagePeakTime);
      Serial.print("Average rotations per minute: ");
      Serial.print(rpm);
      Serial.println(" rpm");
        lcd.setCursor(0, 1);
        lcd.print(rpm);

      // Reset variables for next set of measurements
      measurementCount = 0;
      totalPeakTime = 0;
    }
  }
}
